SystemOrganization addCategory: #KEGParameter!

!OrderedCollection methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:32'!
p: aParameter

	"Method Version: keg1.  "
	" Copyright Kjell E God Nov 14 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Nov 14 1999"
								"( MT b:#p: s:self )."
	self add: aParameter .
								"( MT e:#p: s:self )."

	"Self is being used as a parameter passing structure.  Don't return aParameter so that
	a trailing >>yourself will not need to be sent to self.  self( this method ) is good for stuff like
	( oc new p:( a );p:( b );p:( c );p:( d ) ) where oc := OrderedCollection."

! !

!Array class methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:25'!
p1: anObject1 p2: anObject2

	"Method Version: keg1.  "
	"Copyright Kjell E God March 02 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today March 02 2000"
				"MT b:#p1:p2: s:self ."

	^( self new:2 ) at:1put: anObject1 ; at:2put: anObject2 ; yourself .

				"MT e:#p1:p2: s:self ."

	"Get a new instance of self and fill it and return it."

! !

!Array class methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:26'!
"(| defineMethod-:(" p1: anObject1 p2: anObject2 p3: anObject3 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20020930
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20020930
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#p1:p2:p3: s:self )."

	^(
		( ( self new:3 )
			at:1put: anObject1 ; at:2put: anObject2 ; at:3put: anObject3 ;
			yourself )

	)"return:( 					MT e:#p1:p2:p3: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Create a new size=3 Array and fill it with the three input parameters. And return it.

 )-summary
 methodDescriptionDetail-:(

	This is usually used for parameter passing.  There is an alternative way of doing
	parameter passing that uses a few global instances of KEGParam Arrays.  Which
	perhaps could be faster but it has never been timed.  I suppose the Array allocation
	primative could actually be faster.
	
 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!Array class methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:27'!
p1: anObject1 p2: anObject2 p3: anObject3 p4: anObject4

	"Method Version: keg1.  "
	"Copyright Kjell E God July 29 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today July 29 2000"
				"MT b:#p1:p2:p3:p4: s:self ."

	^( self new:4 ) at:1put: anObject1 ; at:2put: anObject2 ; at:3put: anObject3 ; at:4put: anObject4 ; yourself .

				"MT e:#p1:p2:p3:p4: s:self ."! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:06'!
"(| defineMethod-:(" isParam ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021004
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021004
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:(					( MT b:#isParam s:self )."
	^(
		( true )

	)"return:( 					MT e:#isParam s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Instances of Array will now be isParams because they have been trying to force
	themselves into that position for a while so we will just let them have it.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:08'!
p1

	"Method Version: keg1.  "
	"Copyright Kjell E God October 02 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 02 1999"
				"MT b:#p1 s:self ."

	^self at:1 .

				"MT e:#p1 s:self ."

	"self is assumed be of size at least 1.  Return the first element.  This is mainly used when self is being
	used as a way to ferry parameters around in Generators."
! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:10'!
p1: anObject1

	"Method Version: keg1.  "
	" Copyright Kjell E God 20010115"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20010115"
				"MT b:#p1: s:self ."

	self at:1put: anObject1 .

				"MT e:#p1: s:self ."

	"self is assumed be of size at least 1.  We set the first slot.
	This can be used for parameter passing.  It can also be used by the 
	Generators to pump parameters into reusable semi global parameters. So why would you wrap
	a single Object O in an Array?  Why not just pass O itself as the parameter?  Well some of the
	KEG methods behave differently if the parameter is wrapped in an Array.  It is also convenient
	for making parameters to the KEGGenerator>>replaceAll:with: method."
! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:22'!
p1: anObject1 p2: anObject2

	"Method Version: keg1.  "
	"Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today September 23 1999"
				"MT b:#p1:p2: s:self ."

	self at:1put: anObject1 ; at:2put: anObject2 .

				"MT e:#p1:p2: s:self ."
	"self is assumed be of size at least 2.  We set the first two slots.
	This can be used for parameter passing.  It can also be used by the 
	Generators to pump parameters into reusable semi global parameters.
	This method is here so that the method search doesn't have to go up to the super class.  I don't know
	if this is worth space for speed it but there it is."

! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:12'!
p1: anObject1 p2: anObject2 p3: anObject3

	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"

				"MT b:#p1:p2:p3: s:self ."

	self at:1put: anObject1 ; at:2put: anObject2 ; at:3put: anObject3 .

				"MT e:#p1:p2:p3: s:self ."
	"self is assumed be of size at least 3.  We set the first 3 slots.
	This can be used for parameter passing.  It can also be used by the 
	Generators to pump parameters into reusable semi global parameters.
	This method is here so that the method search doesn't have to go up to the super class.  I don't know
	if this is worth space for speed it but there it is."

! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:13'!
p1: anObject1 p2: anObject2 p3: anObject3 p4: anObject4

	"Method Version: keg1.  "
	"Copyright Kjell E God July 29 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint July 29 2000"
				"MT b:#p1:p2:p3:p4: s:self ."

	^( self  
		at:1put: anObject1 ;
		at:2put: anObject2 ;
		at:3put: anObject3 ;
		at:4put: anObject4 ;
		yourself )

				"MT e:#p1:p2:p3:p4: s:self ."
! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:15'!
p2

	"Method Version: keg1.  "
	"Copyright Kjell E God October 02 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 02 1999"
				"MT b:#p2 s:self ."

	^self at:2 .

				"MT e:#p2 s:self ."

	"self is assumed be of size at least 2.  Return the second element.  
	This is mainly used when self is being
	used as a way to ferry parameters around in Generators."
! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:16'!
"(| defineMethod-:(" p2: anObject ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021120
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021120
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:(							( MT b:#p2; s:self )."
	( self at:2put: anObject ).

	"^( self )return:( 					MT e:#p2; s:self )

    )-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Set the value of the second slot in self.

 )-summary
 methodDescriptionDetail-:(

	All the >>p1: >>p2: >>p1:p2: etc KEGParameter Package methods must
	return self.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:17'!
p3

	"Method Version: keg1.  "
	" Copyright Kjell E God 20010115"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20010115"
				"MT b:#p3 s:self ."

	^self at:3 .

				"MT e:#p3 s:self ."

	"self is assumed be of size at least 3.  Return the third element.  This is mainly used when self is being
	used as a way to ferry parameters around in Generators."


			! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:18'!
"(| defineMethod-:(" p4 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030124
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030124
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#p4 s:self )."
	^(
		( self at:4 )

	)"return:( 					MT e:#p4 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	Return the forth element of self.
 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:19'!
"(| defineMethod-:(" p5 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030124
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030124
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#p5 s:self )."
	^(
		( self at:5 )

	)"return:( 					MT e:#p5 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	Return the fifth element of self.
 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:20'!
"(| defineMethod-:(" p6 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030124
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030124
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#p6 s:self )."

	^(
		( self at:6 )

	)"return:( 					MT e:#p6 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	Return the sixth element of self.
 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!Array methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:21'!
"(| defineMethod-:(" p7 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030124
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030124
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#p7 s:self )."
	^(
		( self at:7 )

	)"return:( 					MT e:#p7 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	Return the seventh element of self.
 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

Array variableSubclass: #KEGParam
	instanceVariableNames: 'size'
	classVariableNames: 'Cache Index'
	poolDictionaries: ''
	category: 'KEGParameter'!

!KEGParam commentStamp: 'KjellGodo 10/13/2012 10:40' prior: 0!
KEGParam has been used to ferry input parameters into KEGGenerator creation Methods.  In this way such Methods can be overloaded so to speak.  Instead of making several methods with similar names just one method was made and you could send different input parameters into it to get it to do different things.  Thus the different implementations inside of the Method came one after another and you could scroll up and down to see the similarities and differences quickly.  But this did make some of these Methods very long and complex looking.  But if you look at them closer you can see that they are split up by a case statement made out of ifTrue:ifFalse: .  On first light it seems like a dirtier way to do things.  But oh well.  That is the way that it has been done.  When implementing it seems better to have everything in one place all at once and just scroll up and down to see it all.  But when reading it seems better to split large methods up into similar named Methods.  Oh well.  It's too late now.

Instance Variables:
	size	the number of non nil slots that have data ( it's not really used as of yet )
		

	This Class is licensed as MIT open source.  Please evaluate ( Object licenseMIT ) for details
	or see KEGLicense class>>licenseMIT .

This Class provides variability in parameter passing.   Which enhances reusability.

If you have a method m: which takes one parameter:

	m: param

And in future you decide that you really want to allow 3 parameters to go into m:
then you can do:
	p := KEGParam.
	. . .
	m:( p p1: param1 p2: param2 p3: param3 )

And inside of m: you can do-:

m: anObject

	pam3 := ( anObject isParam 
		ifTrue:[ pam1 := anObject p1 . pam2 := anObject p2 . anObject p3 ]
		ifFalse:[ anObject ] .

or some such like thing.  Thus m: works just like it always did but now you can stuff this other stuff
down it if you like too.  And believe me this can make things more reusable.  So if reusability is your
game then self( this Class ) is your way.  One of your ways.

PLEASE-NOTE-:
In a potentially vain attempt to speed things up you are restricted to using at most 5 different KEGParams in the entire system at one time.  Experience has shown this to be sufficient.  If it is not
then try using Arrays instead in that one case.   Also you must use the self>>p1, self>>p2, self>>p3 methods to get the values out of instances of self because they set those slots to nil as they return the values in the slots.  Otherwise you may wind up globalizing Objects that you didn't want to Globalize.  Globalizing means that they may stick around until after you expected them to be garbage collected.  This can rapidly get messy if you are passing large Objects as parameters.  Also you might be afraid that big Objects like Model View Presenter clusters might get Globalized and stick around across image saves. It has happened.  Believe me it has.  But not in Dolphin Smalltalk because of the #imageSaveStarting event which clears out the Cache of KEGParams just prior to the image save.  So hopefully those Globalized Objects that persisted because you are an All American Homer Simpson and are not going to use >>p1 >>p2 >>p3 even though I just told you to will still not persist across image saves.

Also if you set a parameter into a KEGParam then you have to flush it out of there using the >>p1 >>p2 >>p3 methods.  Don't leave it in there.  Because it will get Globalized until the end of the session or the next image save.

Listen KEGParams are meant to be filled, passed into a method and almost immediately first thing on the other side dissembowelled on the spot of their cargo.   If you wait around and let other methods get called before you empty out the KEGParam then one of those other methods that just got called might overwrite the KEGParams you just filled.  Thus filling your pants instead of your traget method.  So just remember.  You only get 5.   Count them 5.  In the whole system.   Which long experience tells us is sufficient if they are used as they were intended.   They should only be expected to contain relevant data across a single method send.   If you want more persistance than that then use Arrays in those limited number of cases where you need more persistance.  I hope I have made myself clear by now.  Good.!

!KEGParam class methodsFor: 'class initialization' stamp: 'KjellGodo 10/13/2012 10:12'!
initializeKEG
	"Method Version: keg1.  "
	" Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
						"MT b:#initializeKEG s:self."

	Index := 1 .
	Cache := 1 to: 5 .
	Cache := Cache collect:[ :i | self new: 10 ] .
	
						"MT e:#initializeKEG s:self."

	"Initialize self.  This is an initialization that is parallel to the Dolphin 
	initialize.   It does not want to get tangled up in the Dolphin initializes so
	it is seperate.  The default is to do nothing.  Here we are going to initialize
	the Cache of preAllocated instances of self.  PLEASE-NOTE-: In the olden days in Smalltalk/V you
	used >>removeFirst and >>removeLast and >>removeAll but now none of this is done in order to
	save time.  When the image is saved then these global variables are cleaned out but not before.
	Although I suppose it couldn't hurt to provide that functionality just in case the programmer wants
	it because too much stuff is hanging around in the global KEGParams.  But then one could just do
	a ( KEGParam initializeKEG ) to clean things out.  But perhaps a faster way would be good too.
	So try self>>removeAll.  Also please note that each of the >>p1 p2 p3 p4 are destrurctive and
	self cleaning.

	PLEASE-NOTE-: If you change the size of the cache in future you must also
	change the self>>new method.  Also each instance of self has a maximum size of 10 items.
	But self>>new doesn't care about that."! !

!KEGParam class methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 10:17'!
new
	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
				"MT b:#new s:self ."

	( Index ifNil:[ self initializeKEG ] ).
	5 <= Index ifTrue:[ Index := 1 ]ifFalse:[ Index := Index + 1 ] . 
	^( Cache at: Index )

				"MT e:#new s:self ."
	"Take one of the 5 preallocated instances of self from the Cache and return it.
	Cache is implemented as a fixed circular Que of size 5. If you want Params that
	are thread safe then use Arrays."
! !

!KEGParam class methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 10:19'!
p1: anObject1

	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
				"MT b:#p1: s:self ."

	^self new at:1put: anObject1 ; size: 1 ; yourself .

				"MT e:#p1: s:self ."

	"Get one of the preAllocated instances of self and fill it and return it."
! !

!KEGParam class methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 10:20'!
p1: anObject1 p2: anObject2

	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
				"MT b:#p1:p2: s:self ."

	^self new at:1put: anObject1 ; at:2put: anObject2 ;  size: 2 ; yourself .

				"MT e:#p1:p2: s:self ."

	"Get one of the preAllocated instances of self and fill it and return it."
! !

!KEGParam class methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 10:21'!
p1: anObject1 p2: anObject2 p3: anObject3

	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
				"MT b:#p1:p2:p3: s:self ."

	^self new at:1put: anObject1 ; at:2put: anObject2 ; at:3put: anObject3 ;  size: 3 ; yourself .

				"MT e:#p1:p2:p3: s:self ."

	"Get one of the preAllocated instances of self and fill it and return it."
! !

!KEGParam class methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 10:23'!
p1: anObject1 p2: anObject2 p3: anObject3 p4: anObject4

	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today November 08 1999"
				"MT b:#p1:p2:p3:p4: s:self ."

	^self new at:1put: anObject1 ; at:2put: anObject2 ; at:3put: anObject3 ; at:4put: anObject4 ;  size: 4 ; yourself .

				"MT e:#p1:p2:p3:p4: s:self ."

	"Get one of the preAllocated instances of self and fill it and return it."
! !

!KEGParam methodsFor: 'testing' stamp: 'KjellGodo 10/13/2012 10:06'!
isParam
	"Method Version: keg1.  "
	"Copyright Kjell E God Dec 23, 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Dec 23, 1994"
                                                  "MT b:#isParam s:self."
                                                  "MT e:#isParam s:self."
	^true .
	"self is a Param."


! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/11/2012 21:13'!
p1
        "Method Version: keg1.  "
        "Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
        "Date of Last Revision: Date today October 28 1999"
	| answer |
				"MT b:#p1 s:self ."

	answer := self at:1 .
	self at:1put: nil .
	size := size - 1 .
				"MT e:#p1 s:self ."
	^answer .
	"self is assumed be of size at least 1.  Return the first element.  
	This is mainly used when self is being used as a way to ferry 
	parameters around in Generators.  Once the parameter is returned then that
	slot is set to nil.  This is because the instances of self( this Class ) are Global."
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/11/2012 21:13'!
p2
	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
	| answer |
				"MT b:#p2 s:self ."

	answer := self at:2 .
	self at:2put: nil .
	size := size - 1 .
				"MT e:#p2 s:self ."
	^answer .
	"self is assumed be of size at least 2.  Return the first element.  
	This is mainly used when self is being used as a way to ferry parameters 
	around in Generators.  Once the parameter is returned then that
	slot is set to nil.  This is because the instances of self( this Class ) are Global."
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/11/2012 21:13'!
p3
	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today October 28 1999"
	| answer |
				"MT b:#p3 s:self ."

	answer := self at:3 .
	self at:3put: nil .
	size := size - 1 .
				"MT e:#p3 s:self ."
	^answer .
	"self is assumed be of size at least 3.  Return the first element.  This is mainly used when self is being
	used as a way to ferry parameters around in Generators.  Once the parameter is returned then that
	slot is set to nil.  This is because the instances of self( this Class ) are Global."
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/11/2012 21:12'!
p4

	"Method Version: keg1.  "
	"Copyright Kjell E God October 28 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today November 08 1999"
	| answer |
				"MT b:#p4 s:self ."

	answer := self at:3 .
	self at:3put: nil .
	size := size - 1 .
				"MT e:#p4 s:self ."
	^answer .
	"self is assumed be of size at least 4.  Return the first element.  This is mainly used when self is being
	used as a way to ferry parameters around in Generators.  Once the parameter is returned then that
	slot is set to nil.  This is because the instances of self( this Class ) are Global."
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 09:58'!
"(| defineMethod-:(" p5 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20020916
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20020916
	)-notes methodBody-:(
 (| let-:("| answer |")
    letBody-:("					"( MT b:#p5 s:self )."
	( answer := self at:5 ).
	( self at:5put: nil ).
	( size := size - 1 ).
	^(
		( answer )

	)"return:( 					MT e:#p5 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	self is assumed be of size at least 5.  Return the fifth element.  This is mainly used when self is being
	used as a way to ferry parameters around in Generators.  Once the parameter is returned then that
	slot is set to nil.  This is because the instances of self( this Class ) are Global.
 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"

! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 10:00'!
"(| defineMethod-:(" p6 ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20020916
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20020916
	)-notes methodBody-:(
 (| let-:("| answer |")
    letBody-:("					"( MT b:#p6 s:self )."
	( answer := self at:6 ).
	( self at:6put: nil ).
	( size := size - 1 ).
	^(
		( answer )

	)"return:( 					MT e:#p6 s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	self is assumed be of size at least 6.  Return the sixth element.  This is mainly used when self is being
	used as a way to ferry parameters around in Generators.  Once the parameter is returned then that
	slot is set to nil.  This is because the instances of self( this Class ) are Global.
 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 todos-:(
	todos
 )-todos
 changes-:(

	(| KEG2-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 10:01'!
removeAll

	"Method Version: keg1.  "
	" Copyright Kjell E God Jan  5 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jan  5 2000"
						"MT b:#removeAll s:self."

	self atAllPut: nil .
	size := 0 .
						"MT e:#removeAll s:self."
	"This is a quick way to get rid of any deutritis that is hanging around in these
	global KEGParams."
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 10:03'!
size
	"Method Version: keg1.  "
	" Copyright Kjell E God Jan  5 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jan  5 2000"
						"MT b:#size s:self."

	( size == nil or:[ size < 0 ] ) ifTrue:[ size := 0 ] .	 

						"MT e:#size s:self."
	^size .
	"Return the number of parameters that were put into self via the class >>p1: >>p1:p2:
	etc methods."
! !

!KEGParam methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 10:04'!
size: anInteger
	"Method Version: keg1.  "
	" Copyright Kjell E God Jan  5 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jan  5 2000"
						"MT b:#size: s:self."
						"MT e:#size: s:self."
	^size := anInteger .
	"PRIVATE-:Set the number of parameters that were put into self via the class >>p1: >>p1:p2:
	etc methods."
! !

!Object methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 10:47'!
@ anObject

	"Method Version: keg1.  "
	" Copyright Kjell E God Feb  1 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Feb  1 2000"
	| answer |
						"MT b:#@ s:self."

	answer := Point x: self y: anObject .

						"MT e:#@ s:self."
	^answer .
	
	"Combine two arbitrary Objects into a Point.  This is convenient for code cleanliness
	when in the common case of passing two parameters down a variable size method
	parameter slot.  Generators provide the variable size parameters so the Generators must
	be installed too.  Unless the parameter slot is to be dependent on Points.
	You convert the variable size parameter using >>asGenerator into a KEGGenerator.
	and then you can get the elements out in a general way that doesn't depend on Point."
! !

!Object methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 10:50'!
"(| defineMethod-:(" asP ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20020716
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20020716
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#asP s:self )."
	^(
		( KEGParam new p1: self )

	)"return:( 					MT e:#asP s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a new KEGParam wrapped around self.
	
 )-summary
 methodDescriptionDetail-:(

	The new KEGParam is a Global
	Object and could be involved in other threads so you should do self-:( this method )
	just prior to calling a method that can take a KEGParam as an input parameter.
	See KEGGenerator>>removeAll: as an example.
	
 )-detail
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-: ( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!Object methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 10:53'!
isParam

	"Method Version: keg1.  "
	"Copyright Kjell E God Dec 23, 1994"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Dec 23, 1994"

	"self is not a Param."

                                                  "MT b:#isParam s:self."
                                                  "MT e:#isParam s:self."
	^false .

! !

!BlockClosure methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 10:57'!
p1: anObject

	"Method Version: keg1.  "
	"Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today April 13, 1999 "

	"| answer |"
				"MT b:#p1: s:self ."

	"answer :=" ^self value: anObject .

				"MT e:#p1: s:self ."
	"^answer ."

	"This method follows the KEGParameter protocal where messages like
	>>p1:        and          >>p1:p2:            and             >>p1:p2:p3:
	are to be used exclusively for parameter passing in and out of methods.
	self( this method ) extends this idea to BlockClosures ( or Blocks ).
	Dependency-: This functionality is used explicitely at this time by 
	the KEGGenerator>>disperse: method."
! !

!BlockClosure methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 10:59'!
p1: anObject1 p2: anObject2

	"Method Version: keg1.  "
	"Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today April 13, 1999 "
	| answer |
				"MT b:#p1:p2: s:self ."

	answer := self value: anObject1 value: anObject2 .

				"MT e:#p1:p2: s:self ."
	^answer .
	
	"This is a shorter version of the value:value: method for when we need more brevity."

! !

!SequenceableCollection methodsFor: '*KEGParameter' stamp: 'KjellGodo 10/13/2012 11:03'!
p1: anObject1 p2: anObject2

	"Method Version: keg1.  "
	"Copyright Kjell E God April 13, 1999"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today April 13, 1999 "
				"MT b:#p1:p2: s:self ."

	self at:1put: anObject1 ; at:2put: anObject2 .

				"MT e:#p1:p2: s:self ."
	"self is assumed be of size at least 2.  We set the first two slots.
	This can be used for parameter passing.  It can also be used by the 
	Generators to pump parameters into reusable semi global parameters."

! !
